/*
	Copyright 2014 Michele "King_DuckZ" Santullo

	This file is part of CloonelJump.

	CloonelJump is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CloonelJump is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CloonelJump.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "drawableline.hpp"
#include "sdlmain.hpp"
#include <SDL2/SDL.h>

#if defined(WITH_DEBUG_VISUALS)
namespace cloonel {
	namespace {
		///----------------------------------------------------------------------
		///----------------------------------------------------------------------
		void ClipLine (const SDL_Rect& /*parArea*/, Line<uint16_t, 2>& /*parLine*/) {

		}
	} //unnamed namespace

	///--------------------------------------------------------------------------
	///--------------------------------------------------------------------------
	DrawableLine::DrawableLine (SDLMain* parMain, Colour parColour, const LineBase& parLine) :
		LineBase(parLine),
		m_sdlmain(parMain),
		m_colour(parColour)
	{
	}

	///--------------------------------------------------------------------------
	///--------------------------------------------------------------------------
	DrawableLine::DrawableLine (SDLMain* parMain, Colour parColour, const LineBase::Point& parStart, const LineBase::Point& parEnd) :
		LineBase(parStart, parEnd),
		m_sdlmain(parMain),
		m_colour(parColour)
	{
	}

	///--------------------------------------------------------------------------
	///--------------------------------------------------------------------------
	void DrawableLine::Render (const float2& parPos, const float2& parScaling) const {
		SDL_SetRenderDrawColor(m_sdlmain->GetRenderer(), m_colour.r, m_colour.g, m_colour.b, m_colour.a);

		LineBase scaledLine(*this);
		scaledLine += static_cast<ushort2>(parPos);
		scaledLine *= parScaling;
		{
			SDL_Rect screen;
			screen.x = screen.y = 0;
			const ushort2 wh(m_sdlmain->WidthHeight());
			screen.w = wh.x();
			screen.h = wh.y();

			ClipLine(screen, scaledLine);
		}
		//SDL_RenderDrawLine(m_sdlmain->GetRenderer(), x1, y1, x2, y2
		//Returns 0 on success or a negative error code on failure; call SDL_GetError() for more information.
		//http://www.ginkgobitter.org/sdl/?SDL_RenderDrawLine
	}
} //namespace cloonel
#endif
